//$ZTIMER  JOB (001),'INSTALL ZTIMER      ',CLASS=A,MSGCLASS=A          00010000
//*                                                                     00020000
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00030000
//* ASSEMBLE/LINK ZTIMER UTILITY TO SYS2.LINKLIB                      * 00040000
//* INSTALL CATALOGUED PROCEDURE INTO SYS2.PROCLIB                    * 00050000
//* INSTALL ZTIMER COMMAND MEMBER INTO SYS2.CONTROL                   * 00060000
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 00070000
//*                                                                     00080000
//ZTIMER  EXEC ASMFCL,PARM.ASM='LIST,LOAD,NODECK,NOXREF',               00090000
//             MAC1='SYS1.AMODGEN',                                     00100000
//             PARM.LKED='XREF,LET,LIST,NCAL'                           00110000
//ASM.SYSIN DD *                                                        00120000
         TITLE '*** ZTIMER - TSG ACTION REMINDER.                 ***'  00130000
*---------------------------------------------------------------------* 00140000
*    THIS PROGRAM PROVIDES A 'REMINDER' FACILITY FOR EVENTS WHICH     * 00150000
*    OCCUR REGULARLY. THIS PROGRAM WILL ISSUE A WRITE-TO-OPERATOR     * 00160000
*    OR A CONSOLE COMMAND DEPENDING ON THE INPUT.                     * 00170000
*    INPUT:  VIA DDNAME SYSIN (CONTROL STATEMENTS)                    * 00180000
*            VIA DDNAME SMFIN (SMFPRMOO MEMBER IN SYS1.PARMLIB)       * 00190000
*    OUTPUT: TO CONSOLE VIA WTO OR MGCR MACRO.                        * 00200000
*---------------------------------------------------------------------* 00210000
* 12/2004 RETRIEVAL OF SYSTEM ID VIA CONTROL BLOCKS               *JLM* 00220000
*---------------------------------------------------------------------* 00230000
ZTIMER   $PROLOG R12,C='ZTIMER'                                         00240000
*---------------------------------------------------------------------* 00250000
*       GET CURRENT TIME AND DATE INTO CHARACTER FORMAT.              * 00260000
*       CHECK FOR LEAP YEAR AND ADJUST.                               * 00270000
*       EVALUATE DAY OF THE WEEK AND WHETHER WEEK-END OR NOT.         * 00280000
*---------------------------------------------------------------------* 00290000
         TIME  DEC                        GET SYSTEM TIME AND DATE      00300000
         ST    R0,PTIM                    STORE PACKED TIME             00310000
         ST    R1,PDAT                    STORE PACKED DATE             00320000
         STCM  R1,4,YEAREND+1             SAVE 'YY' PART OF DATE        00330000
         ED    CURTMSK(6),PTIM            UNPACK TIME                   00340000
         ED    CURDMSK(7),PDAT+1          UNPACK DATE                   00350000
         SLR   R2,R2                      R2 = 0                        00360000
         CVB   R3,PDATDBL                 R3 = YYDDD IN BINARY          00370000
         D     R2,FULL1000                R3 = YY,  R2 = DDD            00380000
         LR    R4,R3                      KEEP YEARS FOR LATER          00390000
         SRL   R4,2                       R4 = R4 / 4                   00400000
         SLL   R4,2                       R4 = R4 * 4                   00410000
         CR    R3,R4                      ARE YEARS EQUAL ?             00420000
         BNE   NOLEAP                     NO ->                         00430000
         MVC   YEAREND+2(2),LEAPDAYS      LEAP YEARS HAVE 366 DAYS      00440000
NOLEAP   EQU   *                                                        00450000
         ST    R3,YEARS                   SAVE BINARY YEARS             00460000
         ST    R2,DAYS                    SAVE BINARY DAYS              00470000
         SLR   R2,R2                      R2 = 0                        00480000
         LA    R3,365                     R3 = 365                      00490000
         M     R2,YEARS                   R3 = YEARS * 365              00500000
         L     R4,YEARS                   R4 = YEARS IN BINARY          00510000
         BCTR  R4,0                       R4 = R4 - 1                   00520000
         SRL   R4,2                       R4 = R4 / 4                   00530000
         AR    R3,R4                      R3 = R3 + R4                  00540000
         A     R3,DAYS                    R3 = R3 + DDD DAYS            00550000
         ST    R3,TEMP                    SAVE IT FOR NOW               00560000
         SLR   R2,R2                      R2 = 0                        00570000
         D     R2,FULL7                   R3 = INTEGER(R3 / 7)          00580000
         M     R2,FULL7                   R3 = R3 * 7                   00590000
         L     R2,TEMP                    GET BACK PREVIOUS VALUE       00600000
         SR    R2,R3                      R2 = 0 TO 6 (SUN TO SAT)      00610000
         SLL   R2,2                       R2 = R2 * 4                   00620000
         LA    R2,WKDAYS(R2)              R2 -> TABLE ENTRY             00630000
         MVC   WKDAY,0(R2)                EXTRACT WEEKDAY               00640000
         CLC   WKDAY,SATURDAY             IS IT A SATURDAY ?            00650000
         BE    WEEKEND                    YES ->                        00660000
         CLC   WKDAY,SUNDAY               IS IT A SUNDAY ?              00670000
         BNE   WEEKDAY                    NO ->                         00680000
WEEKEND  EQU   *                                                        00690000
         MVC   DAYTYPE,WKEND              SET DAYTYPE TO 'WEEK-END'     00700000
WEEKDAY  EQU   *                                                        00710000
*---------------------------------------------------------------------* 00720000
*        CALCULATE NEXT INVOCATION OF ZTIMER                          * 00730000
*        (2 HRS HENCE OR AT NEXT EVENT WHICHEVER COMES EARLIER)       * 00740000
*        GET SYSTEM-ID FROM SMF PARAMETERS                            * 00750000
*---------------------------------------------------------------------* 00760000
         OI    PTIM+3,X'0F'               GIVE A DECENT SIGN TO PTIM    00770000
         SRP   PTIM,64-1,0                SHIFT RIGHT 1 DIGIT POS       00780000
         AP    PTIM,HRS2                  TIME = TIME + 2 HOURS         00790000
         ED    NXTTMSK(7),PTIM            TIME FOR NEXT EXECUTION       00800000
         CP    PTIM,DAYEND                DID WE PASS MIDNIGHT ?        00810000
         BNH   SAMEDAY                    NO ->                         00820000
         MVC   NXTTIM+1(5),TWENTY4        NEXT EXECUTION IS AT MIDNIGHT 00830000
SAMEDAY  EQU   *                                                  *JLM* 00840000
*         OPEN  (SMFIN,(INPUT))            OPEN SMF PARMLIB MEMBER*JLM* 00850000
*SMFREAD  EQU   *                                                 *JLM* 00860000
*         GET   SMFIN,INAREA               READ A RECORD          *JLM* 00870000
*         LA    R2,INAREA                  R2 -> START OF SMF RECO*JLM* 00880000
*         LA    R4,1                       R4 =  INCREMENT FOR BXL*JLM* 00890000
*         LA    R5,INAREA+68               R5 -> END OF SMF RECORD*JLM* 00900000
*SIDSERCH EQU   *                                                 *JLM* 00910000
*         CLC   0(4,R2),SIDKEY             'SID(' KEYWORD FOUND ? *JLM* 00920000
*         BE    SIDFOUND                   YES ->                 *JLM* 00930000
*         BXLE  R2,R4,SIDSERCH             INCR, CHECK AND LOOP   *JLM* 00940000
*         B     SMFREAD                    NOT FOUND, TRY NEXT CAR*JLM* 00950000
*SMFEOF   EQU   *                                                 *JLM* 00960000
*         MVC   SYSID,BLANKS               NO SYSID FOUND.        *JLM* 00970000
*         B     SYSIDOK                                           *JLM* 00980000
*SIDFOUND EQU   *                                                 *JLM* 00990000
*         MVC   SYSID,4(R2)                SAVE CURRENT SYSTEM-ID *JLM* 01000000
*SYSIDOK  EQU   *                                                 *JLM* 01010000
*         CLOSE SMFIN                      CLOSE INPUT FILE       *JLM* 01020000
          USING PSA,R2                     PSA BASE               *JLM* 01030000
          USING CVT,R4                     CVT BASE               *JLM* 01040000
          USING SMCABASE,R5                SMCA BASE              *JLM* 01050000
          XR    R2,R2                      POINT TO PSA (0)       *JLM* 01060000
          L     R4,FLCCVT                  POINT TO CVT           *JLM* 01070000
          L     R5,CVTSMCA                 POINT TO SMCA          *JLM* 01080000
          MVC   SYSID,SMCASID              RETRIEVE SMF-ID        *JLM* 01090000
          DROP  R2,R4,R5                   RELEASE BASES          *JLM* 01100000
*---------------------------------------------------------------------* 01110000
*        READ EACH RECORD, AND CHECK FORMAT, DATE AND SYSTEM-ID       * 01120000
*---------------------------------------------------------------------* 01130000
         OPEN  (SYSIN,(INPUT))            OPEN INPUT FILE               01140000
READ     EQU   *                                                        01150000
         GET   SYSIN,INAREA               READ A RECORD                 01160000
         CLI   INAREA,C'*'                IS THIS A COMMENT CARD ?      01170000
         BE    READ                       YES ->                        01180000
         CLC   INAREA(3),ALL              TO BE DONE ON 'ALL' DAYS ?    01190000
         BE    CHKSYSID                   YES ->                        01200000
         CLC   INAREA(5),DAYTYPE          TO BE DONE ON THIS TYP OF DAY 01210000
         BE    CHKSYSID                   YES ->                        01220000
         CLC   INAREA(3),WKDAY            TO BE DONE ON THIS WEEKDAY ?  01230000
         BE    CHKSYSID                   YES ->                        01240000
         LA    R2,WKDAYS                  R2 -> WEEKDAY TABLE           01250000
         LA    R4,4                       R4 =  LENGTH OF TABLE ENTRIES 01260000
         LA    R5,WKDAYS+24               R5 -> END OF WEEKDAY TABLE    01270000
DAYSERCH EQU   *                                                        01280000
         CLC   INAREA(3),0(R2)            TO BE DONE ON ANOTHER DAY ?   01290000
         BE    READ                       YES ->                        01300000
         BXLE  R2,R4,DAYSERCH             INCR, CHECK AND LOOP          01310000
         CLC   INAREA(5),WKEND            TO BE DONE ON A WEEKEND ?     01320000
         BE    READ                       YES ->                        01330000
         CLC   INAREA(5),WORKDAY          TO BE DONE IN THE WEEK ?      01340000
         BE    READ                       YES ->                        01350000
         CLC   INAREA(5),CURDAT           TO BE DONE ON THIS JULDATE ?  01360000
         BE    CHKSYSID                   YES ->                        01370000
         CLI   INAREA+2,C'/'              VALID DATE SEPARATOR ?        01380000
         BNE   DUFFCARD                   NO ->                         01390000
         CLI   INAREA+5,C'/'              VALID DATE SEPARATOR ?        01400000
         BNE   DUFFCARD                   NO ->                         01410000
         BAL   R14,CALTOJUL               DDMMYY TO YYDDD CONVERSION    01420000
         CLC   JULDAT,CURDAT              TO BE DONE TODAY ?            01430000
         BNE   READ                       NO ->                         01440000
CHKSYSID EQU   *                                                        01450000
         CLC   INSYSID,BLANKS             WAS A SYSTEM-ID SPECIFIED ?   01460000
         BE    CHKTIME                    NO -> GO AND CHECK TIME       01470000
         CLC   INSYSID,SYSID              ACTION FOR THIS SYSTEM ?      01480000
         BNE   READ                       NO ->                         01490000
*---------------------------------------------------------------------* 01500000
*        CHECK TIME OR EXECUTION AND TYPE OF ACTION REQUIRED.         * 01510000
*        PERFORM THE REQUIRED FUNCTION.                               * 01520000
*---------------------------------------------------------------------* 01530000
CHKTIME  EQU   *                                                        01540000
         CLC   INTIME,BLANKS              WAS A TIME SPECIFIED ?        01550000
         BE    EXECUTE                    NO -> GO AND DO IT            01560000
         CLC   INTIME,CURTIM              WHEN IS THE EVENT FOR ?       01570000
         BE    EXECUTE                    NOW -> GO AND DO IT           01580000
         BL    READ                       BEFORE -> IGNORE IT           01590000
         CLC   INTIME,NXTTIM+1            BEFORE THE NEXT EXECUTION ?   01600000
         BH    READ                       NO -> IGNORE IT               01610000
         MVC   NXTTIM+1(5),INTIME         ENSURE WE CATCH HIM           01620000
         B     READ                       GET NEXT CARD                 01630000
EXECUTE  EQU   *                                                        01640000
         CLC   INTYPE,COMMAND             IS IT A COMMAND REQUEST ?     01650000
         BE    ISSUECOM                   YES ->                        01660000
* ADDED 2ND WTO AND COMPARE FOR 'DSH'/'DSN'                       *JLM* 01670000
         CLC   INTYPE,DISPLAYH            IS IT A DISPLAY REQUEST ?     01680000
         BE    ISSUEDSH                   YES ->                        01690000
         CLC   INTYPE,DISPLAYN            IS IT A DISPLAY REQUEST ?     01700000
         BNE   DUFFCARD                   NO ->                         01710000
ISSUEDSN MVC   MESSAGEN+8(49),INACTN      MOVE MESSAGE TO WTO AREA      01720000
MESSAGEN WTO   '....+....1....+....2....+....3....+....4....+....'      01730000
         B     READ                       GO BACK FOR MORE              01740000
ISSUEDSH MVC   MESSAGEH+8(49),INACTN      MOVE MESSAGE TO WTO AREA      01750000
MESSAGEH WTO   '....+....1....+....2....+....3....+....4....+....',    C01760000
               DESC=(2)                   TELL 'EM                      01770000
         B     READ                       GO BACK FOR MORE              01780000
ISSUECOM EQU   *                                                        01790000
         MVC   COMACTN(49),INACTN         MOVE COMMAND TO COM AREA      01800000
         MODESET KEY=ZERO,MODE=SUP        SWITCH TO SUPERVISOR STATE    01810000
         SLR   R0,R0                      PRETEND YOU'RE MVS            01820000
         MGCR  COMAREA                    ISSUE THE COMMAND             01830000
         MODESET KEY=NZERO,MODE=PROB      SWITCH BACK TO NORMAL         01840000
         B     READ                       GO BACK FOR MORE              01850000
*---------------------------------------------------------------------* 01860000
*        END-OF-FILE HANDLING.                                        * 01870000
*        RETURN TO CALLER.                                            * 01880000
*        DUFF INPUT HANDLING.                                         * 01890000
*---------------------------------------------------------------------* 01900000
EOF      EQU   *                                                        01910000
         CLOSE SYSIN                      CLOSE INPUT FILE              01920000
         MVC   AUTOTIME,NXTTIM+1          MOVE NEXT TIME TO AUTO-COMM   01930000
         MODESET KEY=ZERO,MODE=SUP        SWITCH TO SUPERVISOR STATE    01940000
         SLR   R0,R0                      PRETEND YOU'RE MVS            01950000
         MGCR  SCHEDULE                   ISSUE THE AUTOMATIC COMMAND   01960000
         MODESET KEY=NZERO,MODE=PROB      SWITCH BACK TO NORMAL         01970000
         $EPILOG                                                        01980000
DUFFCARD EQU   *                                                        01990000
         WTO   'ZTIMER: INVALID INPUT DETECTED - DUFF CARD READS:'      02000000
         MVC   DUFFMSG+8(54),INAREA                                     02010000
DUFFMSG  WTO   '....+....1....+....2....+....3....+....4....+....5....' 02020000
         B     READ                       IGNORE THIS ONE               02030000
*---------------------------------------------------------------------* 02040000
*        CALENDER DATE (DD/MM/YY) TO JULIAN DATE (YY.DDD) CONVERSION  * 02050000
*        INPUT AREA IS FIELD CALLED 'INDATE'                          * 02060000
*        OUTPUT AREA IS FIELD CALLED 'JULDAT'                         * 02070000
*---------------------------------------------------------------------* 02080000
CALTOJUL EQU   *                                                        02090000
*        PACK  DAY,INDATE(2)              EXTRACT DAY PORTION     *JLM* 02100000
*        PACK  MONTH,INDATE+3(2)          EXTRACT MONTH PORTION   *JLM* 02110000
         PACK  MONTH,INDATE(2)            EXTRACT MONTH PORTION   *JLM* 02120000
         PACK  DAY,INDATE+3(2)            EXTRACT DAY PORTION     *JLM* 02130000
         PACK  YEAR,INDATE+6(2)           EXTRACT YEAR PORTION          02140000
         CVB   R5,MONTHDBL                R5 = MONTH IN BINARY          02150000
         BCTR  R5,0                       R5 = R5 - 1                   02160000
         SLL   R5,1                       R5 = R5 * 2                   02170000
         LH    R2,TABLE(R5)               EXTRACT CUMULATIVE DAYS       02180000
         CVB   R3,YEARDBL                 R3 = YEAR IN BINARY           02190000
         LR    R5,R3                      R5 = YEAR IN BINARY           02200000
         SRL   R3,2                       R3 = R3 / 4                   02210000
         SLL   R3,2                       R3 = R3 * 4                   02220000
         CR    R3,R5                      WAS IT A LEAP YEAR ?          02230000
         BNE   MNTHREDY                   NO ->                         02240000
         CP    MONTH,PACK2                IS IT PAST FEBRUARY ?         02250000
         BNH   MNTHREDY                   NO ->                         02260000
         LA    R2,1(R2)                   ADD 1 FOR THE 29TH            02270000
MNTHREDY EQU   *                                                        02280000
         CVB   R3,DAYDBL                  R3 = DAY IN BINARY            02290000
         AR    R2,R3                      R2 = TOTAL DAYS               02300000
         M     R4,FULL1000                R5 = YEAR * 1000              02310000
         AR    R5,R2                      R5 = R5 + DAYS                02320000
         CVD   R5,DOUBLE                  CONVERT DATE TO PACKED        02330000
         MVC   JULDATF(7),JULDMSK         MOVE EDIT MASK TO FIELD       02340000
         ED    JULDATF(7),DOUBLE+5        FORMAT INTO CHAR FIELD        02350000
         BR    R14                        RETURN TO CALLER              02360000
*---------------------------------------------------------------------* 02370000
*        CONSTANT DATA AREAS.                                         * 02380000
*---------------------------------------------------------------------* 02390000
FULL7    DC    F'7'                       CONSTANT                      02400000
FULL1000 DC    F'1000'                    CONSTANT                      02410000
PACK2    DC    PL2'2'                     CONSTANT                      02420000
HRS2     DC    PL4'020000'                02 HOURS                      02430000
HRS24    DC    PL4'240000'                24 HOURS                      02440000
DAYEND   DC    PL4'235959'                END OF DAY (MIDNIGHT - 1 MIN) 02450000
YEAREND  DC    PL4'365'                   END OF YEAR                   02460000
LEAPDAYS DC    PL2'366'                   NO OF DAYS IN A LEAP YEAR     02470000
CURDMSK  DC    CL1'0'                     FILL CHAR                     02480000
CURDAT   DC    XL6'21204B202020'          CURRENT DATE   (YY.DDD)       02490000
CURTMSK  DC    CL1'0'                     FILL CHAR                     02500000
CURTIM   DC    XL5'21204B2020'            CURRENT TIME  (HH.MM)         02510000
NXTTMSK  DC    CL1'0'                     FILL CHAR                     02520000
NXTTIM   DC    XL6'2120204B2020'          TIME OF NEXT EXECUTION        02530000
JULDMSK  DC    XL7'F021204B202020'        JULIAN DATE EDIT MASK         02540000
JULDATF  DS    XL1                        FILL CHAR                     02550000
JULDAT   DS    XL6                        JULIAN DATE                   02560000
TABLE    DC    H'000',H'031',H'059',H'090',H'120',H'151'                02570000
         DC    H'181',H'212',H'243',H'273',H'304',H'334'                02580000
WKDAYS   DC    C'SUN MON TUE WED THU FRI SAT'  ALL THE WEEKDAYS         02590000
ALL      DC    CL3'ALL'                   CONSTANT                      02600000
TWENTY4  DC    CL5'24.00'                 CONSTANT                      02610000
BLANKS   DC    CL5'     '                 CONSTANT                      02620000
DISPLAYH DC    CL3'DSH'                   CONSTANT                      02630000
DISPLAYN DC    CL3'DSN'                   CONSTANT                      02640000
COMMAND  DC    CL3'COM'                   CONSTANT                      02650000
SATURDAY DC    CL3'SAT'                   CONSTANT                      02660000
SUNDAY   DC    CL3'SUN'                   CONSTANT                      02670000
SIDKEY   DC    CL4'SID('                  CONSTANT                      02680000
WKEND    DC    CL5'WKEND'                 CONSTANT                      02690000
WORKDAY  DC    CL5'WKDAY'                 CONSTANT                      02700000
DAYTYPE  DC    CL5'WKDAY'                 EITHER 'WKDAY' OR 'WKEND'     02710000
COMAREA  DS    0F                         COMMAND AREA                  02720000
         DC    H'70'                      LENGTH                        02730000
         DC    X'0000'                    FLAGS                         02740000
COMACTN  DC    CL80' '                    COMMAND FIELD                 02750000
SCHEDULE DS    0F                         AUTOMATIC COMMAND AREA        02760000
         DC    H'37'                      LENGTH                        02770000
         DC    X'0000'                    FLAGS                         02780000
         DC    CL08'$TA99,T='                                           02790000
AUTOTIME DC    CL05'00.00'                TIME FOR NEXT EXECUTION       02800000
         DC    CL80',''$VS,''''S ZTIMER'''''''                          02810000
*---------------------------------------------------------------------* 02820000
*        OTHER STORAGE REQUIREMENTS                                   * 02830000
*---------------------------------------------------------------------* 02840000
DOUBLE   DS    D                          WORK SPACE FOR CONVERSIONS    02850000
PTIMDBL  DC    XL4'0'                                                   02860000
PTIM     DC    PL4'0'                     PACKED TIME FORMAT HHMMSSCC   02870000
PDATDBL  DC    XL4'0'                                                   02880000
PDAT     DC    PL4'0'                     PACKED DATE FORMAT 00YYDDDF   02890000
DAYDBL   DC    XL5'0'                                                   02900000
DAY      DC    PL3'0'                     WORKSPACE - JULTOCAL          02910000
MONTHDBL DC    XL5'0'                                                   02920000
MONTH    DC    PL3'0'                     WORKSPACE - JULTOCAL          02930000
YEARDBL  DC    XL5'0'                                                   02940000
YEAR     DC    PL3'0'                     WORKSPACE - JULTOCAL          02950000
TEMP     DS    F                          WORKSPACE                     02960000
YEARS    DS    F                          YEARS IN BINARY               02970000
DAYS     DS    F                          DAYS IN BINARY                02980000
WKDAY    DS    CL3                        TODAY'S WEEK DAY              02990000
SYSID    DS    CL4                        SMF SYSID OF CURRENT SYSTEM   03000000
INAREA   DS    0CL80                      INPUT AREA                    03010000
INDATE   DS    CL08                       DATE FORMAT DD/MM/YY          03020000
         DS    CL01                                                     03030000
INTIME   DS    CL05                       TIME FORMAT HH.MM OR BLANK    03040000
         DS    CL01                                                     03050000
INTYPE   DS    CL03                       ACTION TYPE DISPLAY/COMMAND   03060000
INSYSID  DS    CL04                       SMF SYSTEM-ID OF TARGET SYS   03070000
         DS    CL01                                                     03080000
INACTN   DS    CL49                       COMMAND OR MESSAGE            03090000
         DS    CL08                                                     03100000
*---------------------------------------------------------------------* 03110000
*        DATA CONTROL BLOCKS.                                         * 03120000
*---------------------------------------------------------------------* 03130000
SYSIN    DCB   DDNAME=SYSIN,DSORG=PS,MACRF=(GM),EODAD=EOF               03140000
*SMFIN    DCB   DDNAME=SMFIN,DSORG=PS,MACRF=(GM),EODAD=SMFEOF     *JLM* 03150000
         PUSH PRINT                                                     03160000
         PRINT OFF                                                      03170000
         IHAPSA DSECT=YES              PREFIXED SAVE AREA         *JLM* 03180000
         CVT    DSECT=YES              COMM VECT TABLE            *JLM* 03190000
         IEESMCA                       SMF CONTROL TABLE          *JLM* 03200000
         POP PRINT                                                      03210000
*---------------------------------------------------------------------* 03220000
*           STEFAN NEUMANN                                            * 03230000
*           SYSTEMS PROGRAMMER                                        * 03240000
*           SUN ALLIANCE PLC (UK)      XEPHON 1987                    * 03250000
*---------------------------------------------------------------------* 03260000
         END                                                            03270000
//LKED.SYSLMOD DD DSN=SYS2.LINKLIB,DISP=SHR                             03280000
//LKED.SYSIN DD *                                                       03290000
  SETCODE AC(1)                                                         03300000
  NAME ZTIMER(R)                                                        03310000
//IEBUPDTE EXEC PGM=IEBUPDTE,PARM=NEW                                   03320000
//SYSPRINT DD  SYSOUT=*                                                 03330000
//SYSUT1   DD  DISP=SHR,DSN=SYS2.PROCLIB                                03340000
//SYSUT2   DD  DISP=SHR,DSN=SYS2.PROCLIB                                03350000
//SYSIN    DD  DATA                                                     03360000
./ ADD NAME=ZTIMER                                                      03370000
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 03380000
//* INVOKE AUTOMATIC COMMAND/MESSAGE UTILITY                          * 03390000
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 03400000
//ZTIMER  PROC MEM=ZTIMER,SOUT=A                                        03410000
//REMINDR EXEC PGM=ZTIMER                                               03420000
//SYSUDUMP DD  SYSOUT=&SOUT                                             03430000
//SYSIN    DD  DISP=SHR,DSN=SYS2.CONTROL(&MEM)                          03450000
./ ENDUP                                                                03460000
/*                                                                      03470000
//IEBUPDTE EXEC PGM=IEBUPDTE,PARM=NEW                                   03480000
//SYSPRINT DD  SYSOUT=*                                                 03490000
//SYSUT1   DD  DISP=SHR,DSN=SYS2.CONTROL                                03500000
//SYSUT2   DD  DISP=SHR,DSN=SYS2.CONTROL                                03510000
//SYSIN    DD  DATA                                                     03520000
./ ADD NAME=ZTIMER                                                      03530000
*----------------------------------------------------------------------*03540000
*             ZTIMER - AUTOMATIC REMINDER/COMMAND FACILITY             *03550000
* COL 1 TO 8:  EITHER DATE IN FORMAT 'DD/MM/YY'                        *03560000
*                 OR DATE IN FORMAT 'YY/DDD'                           *03570000
*                 OR 3-CHAR WEEKDAY 'MON TUE WED THU FRI SAT SUN'      *03580000
*                 OR WORD 'WKDAY' FOR ANY WEEKDAY (MON TO FRI)         *03590000
*                 OR WORD 'WKEND' FOR WEEKEND (SAT AND SUN)            *03600000
*                 OR WORD 'ALL' FOR EVERY DAY EXECUTION                *03610000
*                 OR '*' IN COL 1 FOR A COMMENT CARD.                  *03620000
* COL 10 TO 14:  EITHER TIME IN FORMAT 'HH.MM'                         *03630000
*                 OR BLANKS FOR EXECUTION EVERY TIME.                  *03640000
* COL 16 TO 18:  EITHER 'COM' TO ISSUE COMMAND                         *03650000
*                 OR 'DSH' TO ISSUE A BRIGHT (NON-ROLLABLE) MESSAGE    *03660000
*                 OR 'DSN' TO ISSUE A NORMAL (ROLLABLE) MESSAGE        *03670000
* COL 19 TO 22:  EITHER THE SYSTEM-ID WHERE THE ACTION IS TO BE DONE   *03680000
*                 OR BLANKS FOR ACTION ON ALL SYSTEMS                  *03690000
* COL 24 TO 72:  EITHER THE MESSAGE TO BE DISPLAYED                    *03700000
*                 OR THE COMMAND AS ENTERED AT THE MASTER CONSOLE.     *03710000
*----------------------------------------------------------------------*03720000
*...+....1....+....2....+....3....+....4....+....5....+....6....+....7..03730000
*--------PURGE SYSOUT 'Z' & 'Y' OLDER THAN N DAYS, ALL SYSTEMS          03740000
ALL      00.05 DSN     $OQ,Q=Z,CANCEL,D=5                               03750000
ALL      00.05 COM     $OQ,Q=Z,CANCEL,D=5                               03760000
ALL      00.05 DSN     $OQ,Q=Y,CANCEL,D=5                               03770000
ALL      00.05 COM     $OQ,Q=Y,CANCEL,D=5                               03780000
*                                                                       03790000
./ ENDUP                                                                03800000
/*                                                                      03810000
//                                                                      03820000
